#include "rust/cxx.h"

namespace blake2b {
  struct State;
}

namespace blake2b {
#ifndef CXXBRIDGE1_STRUCT_blake2b$State
#define CXXBRIDGE1_STRUCT_blake2b$State
struct State final : public ::rust::Opaque {
  ::rust::Box<::blake2b::State> box_clone() const noexcept;
  void update(::rust::Slice<::std::uint8_t const> input) noexcept;
  void finalize(::rust::Slice<::std::uint8_t > output) const noexcept;
  ~State() = delete;

private:
  friend ::rust::layout;
  struct layout {
    static ::std::size_t size() noexcept;
    static ::std::size_t align() noexcept;
  };
};
#endif // CXXBRIDGE1_STRUCT_blake2b$State

extern "C" {
::std::size_t blake2b$cxxbridge1$State$operator$sizeof() noexcept;
::std::size_t blake2b$cxxbridge1$State$operator$alignof() noexcept;

::blake2b::State *blake2b$cxxbridge1$init(::std::size_t output_len, ::rust::Slice<::std::uint8_t const> personalization) noexcept;

::blake2b::State *blake2b$cxxbridge1$State$box_clone(::blake2b::State const &self) noexcept;

void blake2b$cxxbridge1$State$update(::blake2b::State &self, ::rust::Slice<::std::uint8_t const> input) noexcept;

void blake2b$cxxbridge1$State$finalize(::blake2b::State const &self, ::rust::Slice<::std::uint8_t > output) noexcept;
} // extern "C"

::std::size_t State::layout::size() noexcept {
  return blake2b$cxxbridge1$State$operator$sizeof();
}

::std::size_t State::layout::align() noexcept {
  return blake2b$cxxbridge1$State$operator$alignof();
}

::rust::Box<::blake2b::State> init(::std::size_t output_len, ::rust::Slice<::std::uint8_t const> personalization) noexcept {
  return ::rust::Box<::blake2b::State>::from_raw(blake2b$cxxbridge1$init(output_len, personalization));
}

::rust::Box<::blake2b::State> State::box_clone() const noexcept {
  return ::rust::Box<::blake2b::State>::from_raw(blake2b$cxxbridge1$State$box_clone(*this));
}

void State::update(::rust::Slice<::std::uint8_t const> input) noexcept {
  blake2b$cxxbridge1$State$update(*this, input);
}

void State::finalize(::rust::Slice<::std::uint8_t > output) const noexcept {
  blake2b$cxxbridge1$State$finalize(*this, output);
}
} // namespace blake2b

extern "C" {
::blake2b::State *cxxbridge1$box$blake2b$State$alloc() noexcept;
void cxxbridge1$box$blake2b$State$dealloc(::blake2b::State *) noexcept;
void cxxbridge1$box$blake2b$State$drop(::rust::Box<::blake2b::State> *ptr) noexcept;
} // extern "C"

namespace rust {
inline namespace cxxbridge1 {
template <>
::blake2b::State *Box<::blake2b::State>::allocation::alloc() noexcept {
  return cxxbridge1$box$blake2b$State$alloc();
}
template <>
void Box<::blake2b::State>::allocation::dealloc(::blake2b::State *ptr) noexcept {
  cxxbridge1$box$blake2b$State$dealloc(ptr);
}
template <>
void Box<::blake2b::State>::drop() noexcept {
  cxxbridge1$box$blake2b$State$drop(this);
}
} // namespace cxxbridge1
} // namespace rust
