#include "zcash/cache.h"
#include "rust/cxx.h"
#include <memory>

namespace rust {
inline namespace cxxbridge1 {
namespace {
template <bool> struct deleter_if {
  template <typename T> void operator()(T *) {}
};

template <> struct deleter_if<true> {
  template <typename T> void operator()(T *ptr) { ptr->~T(); }
};
} // namespace
} // namespace cxxbridge1
} // namespace rust

namespace libzcash {
  using BundleValidityCache = ::libzcash::BundleValidityCache;
}

namespace libzcash {
extern "C" {
::libzcash::BundleValidityCache *libzcash$cxxbridge1$NewBundleValidityCache(::rust::Str kind, ::std::size_t bytes) noexcept {
  ::std::unique_ptr<::libzcash::BundleValidityCache> (*NewBundleValidityCache$)(::rust::Str, ::std::size_t) = ::libzcash::NewBundleValidityCache;
  return NewBundleValidityCache$(kind, bytes).release();
}

void libzcash$cxxbridge1$BundleValidityCache$insert(::libzcash::BundleValidityCache &self, ::std::array<::std::uint8_t, 32> *entry) noexcept {
  void (::libzcash::BundleValidityCache::*insert$)(::std::array<::std::uint8_t, 32>) = &::libzcash::BundleValidityCache::insert;
  (self.*insert$)(::std::move(*entry));
}

bool libzcash$cxxbridge1$BundleValidityCache$contains(::libzcash::BundleValidityCache const &self, ::std::array<::std::uint8_t, 32> const &entry, bool erase) noexcept {
  bool (::libzcash::BundleValidityCache::*contains$)(::std::array<::std::uint8_t, 32> const &, bool) const = &::libzcash::BundleValidityCache::contains;
  return (self.*contains$)(entry, erase);
}
} // extern "C"
} // namespace libzcash

namespace bundlecache {
extern "C" {
void bundlecache$cxxbridge1$init(::std::size_t cache_bytes) noexcept;
} // extern "C"

void init(::std::size_t cache_bytes) noexcept {
  bundlecache$cxxbridge1$init(cache_bytes);
}
} // namespace bundlecache

extern "C" {
static_assert(::rust::detail::is_complete<::libzcash::BundleValidityCache>::value, "definition of BundleValidityCache is required");
static_assert(sizeof(::std::unique_ptr<::libzcash::BundleValidityCache>) == sizeof(void *), "");
static_assert(alignof(::std::unique_ptr<::libzcash::BundleValidityCache>) == alignof(void *), "");
void cxxbridge1$unique_ptr$libzcash$BundleValidityCache$null(::std::unique_ptr<::libzcash::BundleValidityCache> *ptr) noexcept {
  ::new (ptr) ::std::unique_ptr<::libzcash::BundleValidityCache>();
}
void cxxbridge1$unique_ptr$libzcash$BundleValidityCache$raw(::std::unique_ptr<::libzcash::BundleValidityCache> *ptr, ::libzcash::BundleValidityCache *raw) noexcept {
  ::new (ptr) ::std::unique_ptr<::libzcash::BundleValidityCache>(raw);
}
::libzcash::BundleValidityCache const *cxxbridge1$unique_ptr$libzcash$BundleValidityCache$get(::std::unique_ptr<::libzcash::BundleValidityCache> const &ptr) noexcept {
  return ptr.get();
}
::libzcash::BundleValidityCache *cxxbridge1$unique_ptr$libzcash$BundleValidityCache$release(::std::unique_ptr<::libzcash::BundleValidityCache> &ptr) noexcept {
  return ptr.release();
}
void cxxbridge1$unique_ptr$libzcash$BundleValidityCache$drop(::std::unique_ptr<::libzcash::BundleValidityCache> *ptr) noexcept {
  ::rust::deleter_if<::rust::detail::is_complete<::libzcash::BundleValidityCache>::value>{}(ptr);
}
} // extern "C"
